
/* Native Headers */
#define WIN32_NO_STATUS

#include "ntndk.h"  
//#include "ntifs.h"
/* DEFINES ********************************************************************/

#define SMP_DEBUG_FLAG      0x01
#define SMP_ASYNC_FLAG      0x02
#define SMP_AUTOCHK_FLAG    0x04
#define SMP_SUBSYSTEM_FLAG  0x08
#define SMP_INVALID_PATH    0x10
#define SMP_DEFERRED_FLAG   0x20
#define SMP_POSIX_FLAG      0x100
#define SMP_OS2_FLAG        0x200

/* STRUCTURES *****************************************************************/

typedef struct _SMP_REGISTRY_VALUE
{
	LIST_ENTRY Entry;
	UNICODE_STRING Name;
	UNICODE_STRING Value;
	PCHAR AnsiValue;
} SMP_REGISTRY_VALUE, *PSMP_REGISTRY_VALUE;


typedef NTSTATUS(NTAPI  *TFNNtOpenFile)(
	OUT PHANDLE FileHandle,
	IN ACCESS_MASK DesiredAccess,
	IN POBJECT_ATTRIBUTES ObjectAttributes,
	OUT PIO_STATUS_BLOCK IoStatusBlock,
	IN ULONG ShareAccess,
	IN ULONG OpenOptions
	);


typedef VOID(NTAPI *PLDR_CALLBACK)(PVOID CallbackContext, PCHAR Name);

typedef NTSTATUS(NTAPI  *TFNLdrVerifyImageMatchesChecksum)(
	_In_ HANDLE FileHandle,
	_In_ PLDR_CALLBACK Callback,
	_In_ PVOID CallbackContext,
	_Out_ PUSHORT ImageCharacterstics
	);

typedef NTSTATUS(NTAPI  *TFNNtCreateSection)(
	_Out_ PHANDLE SectionHandle,
	_In_ ACCESS_MASK DesiredAccess,
	_In_opt_ POBJECT_ATTRIBUTES ObjectAttributes,
	_In_opt_ PLARGE_INTEGER MaximumSize,
	_In_ ULONG SectionPageProtection,
	_In_ ULONG AllocationAttributes,
	_In_opt_ HANDLE FileHandle
	);
